//+------------------------------------------------------------------+
//|   AutoPivotIndicator_Hourly.mq4          ver 1.0     by Habeeb   |
//|                                                                  |
//|          This one's created for Tokarus.                         |
//+------------------------------------------------------------------+

#property indicator_chart_window

   extern bool Hour_SR_Levels = True;

   double HourHigh;
   double HourLow;
   double HourClose;
   double Hour_Price[][6];
   double HourPivot,HourS1,HourS2,HourS3,HourR1,HourR2,HourR3;
     
int init()
  {
   return(0);
  }
  
int deinit()
  {
  
ObjectDelete("HourPivotLine");

ObjectDelete("Hr_R1_Line");
ObjectDelete("Hr_R2_Line");
ObjectDelete("Hr_R3_Line");

ObjectDelete("Hr_S1_Line");
ObjectDelete("Hr_S2_Line");
ObjectDelete("Hr_S3_Line");  

//--------------------------------

ObjectDelete("HourPivotLabel");

ObjectDelete("Hr_R1_Label");
ObjectDelete("Hr_R2_Label");
ObjectDelete("Hr_R3_Label");

ObjectDelete("Hr_S1_Label");
ObjectDelete("Hr_S2_Label");
ObjectDelete("Hr_S3_Label");  

return(0);
}

//--------------------------------------------------------- 
//--------------------------------------------------------- 

int start()
{
ArrayCopyRates(Hour_Price,(Symbol()), PERIOD_H1);
  
   HourHigh  = Hour_Price[1][3];
   HourLow   = Hour_Price[1][2];
   HourClose = Hour_Price[1][4];
   
   HourPivot = ((HourHigh + HourLow + HourClose)/3);

   HourR1 = (2*HourPivot)-HourLow;
   HourS1 = (2*HourPivot)-HourHigh;

   HourR2 = HourPivot+(HourR1-HourS1);
   HourS2 = HourPivot-(HourR1-HourS1);
   
   HourR3 = (HourHigh + (2*(HourPivot-HourLow)));
   HourS3 = (HourLow - (2*(HourHigh-HourPivot)));  


//--------------------------------------------------------
//--------------------------------------------------------


  TimeToStr(CurTime());
  
 if(ObjectFind("HourPivotLine") != 0)
   {
   ObjectCreate("HourPivotLine", OBJ_HLINE,0, CurTime(),HourPivot);
   ObjectSet("HourPivotLine", OBJPROP_COLOR, Magenta);
   ObjectSet("HourPivotLine", OBJPROP_STYLE, STYLE_DASH);
   }
   else
    {
     ObjectMove("HourPivotLine", 0, Time[20], HourPivot);
    }

 if(ObjectFind("HourPivotLabel") != 0)
   {
    ObjectCreate("HourPivotLabel", OBJ_TEXT, 0, Time[20], HourPivot);
    ObjectSetText("HourPivotLabel", ("Hourly Pivot"), 8, "Arial", Magenta);
   }
   else
    {
     ObjectMove("HourPivotLabel", 0, Time[20], HourPivot);
    }
ObjectsRedraw();

//--------------------------------------------------------

if (Hour_SR_Levels==true)
 {
 
 if(ObjectFind("Hr_R1_Line") != 0)
   {
    ObjectCreate("Hr_R1_Line", OBJ_HLINE,0, CurTime(),HourR1);
    ObjectSet("Hr_R1_Line", OBJPROP_COLOR, Yellow);
    ObjectSet("Hr_R1_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
   }
   else
    {
     ObjectMove("Hr_R1_Line", 0, Time[20], HourR1);
    }

 if(ObjectFind("Hr_R1_Label") != 0)
   {
    ObjectCreate("Hr_R1_Label", OBJ_TEXT, 0, Time[20], HourR1);
    ObjectSetText("Hr_R1_Label", "Hour R1", 8, "Arial", Yellow);
   }
   else
    {
     ObjectMove("Hr_R1_Label", 0, Time[20], HourR1);
    }

//--------------------------------------------------------

 if(ObjectFind("Hr_R2_Line") != 0)
   { 
    ObjectCreate("Hr_R2_Line", OBJ_HLINE,0, CurTime(),HourR2);
    ObjectSet("Hr_R2_Line", OBJPROP_COLOR, Yellow);
    ObjectSet("Hr_R2_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
   }
   else
    {
     ObjectMove("Hr_R2_Line", 0, Time[20], HourR2);
    }
   
 if(ObjectFind("Hr_R2_Label") != 0)
   {
    ObjectCreate("Hr_R2_Label", OBJ_TEXT, 0, Time[20], HourR2);
    ObjectSetText("Hr_R2_Label", "Hour R2", 8, "Arial", Yellow);
   }
   else
    {
     ObjectMove("Hr_R2_Label", 0, Time[20], HourR2);
    }

//---------------------------------------------------------

 if(ObjectFind("Hr_R3_Line") != 0)
   { 
    ObjectCreate("Hr_R3_Line", OBJ_HLINE,0, CurTime(),HourR3);
    ObjectSet("Hr_R3_Line", OBJPROP_COLOR, Yellow);
    ObjectSet("Hr_R3_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
   }
   else
    {
     ObjectMove("Hr_R3_Line", 0, Time[20], HourR3);
    }
   
 if(ObjectFind("Hr_R3_Label") != 0)
   {
    ObjectCreate("Hr_R3_Label", OBJ_TEXT, 0, Time[20], HourR3);
    ObjectSetText("Hr_R3_Label", "Hour R3", 8, "Arial", Yellow);
   }
   else
    {
     ObjectMove("Hr_R3_Label", 0, Time[20], HourR3);
    }

//---------------------------------------------------------

 if(ObjectFind("Hr_S1_Line") != 0)
   {  
    ObjectCreate("Hr_S1_Line", OBJ_HLINE,0, CurTime(),HourS1);
    ObjectSet("Hr_S1_Line", OBJPROP_COLOR, LimeGreen);
    ObjectSet("Hr_S1_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
   }
   else
    {
     ObjectMove("Hr_S1_Line", 0, Time[20], HourS1);
    }
   
 if(ObjectFind("Hr_S1_Label") != 0)
   {
    ObjectCreate("Hr_S1_Label", OBJ_TEXT, 0, Time[20], HourS1);
    ObjectSetText("Hr_S1_Label", "Hour S1", 8, "Arial", LimeGreen);
   }
   else
    {
     ObjectMove("Hr_S1_Label", 0, Time[20], HourS1);
    }

//---------------------------------------------------------

 if(ObjectFind("Hr_S2_Line") != 0)
   {
    ObjectCreate("Hr_S2_Line", OBJ_HLINE,0, CurTime(),HourS2);
    ObjectSet("Hr_S2_Line", OBJPROP_COLOR, LimeGreen);
    ObjectSet("Hr_S2_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
   }
   else
    {
     ObjectMove("Hr_S2_Line", 0, Time[20], HourS2);
    }
   
 if(ObjectFind("Hr_S2_Label") != 0)
   {
    ObjectCreate("Hr_S2_Label", OBJ_TEXT, 0, Time[20], HourS2);
    ObjectSetText("Hr_S2_Label", "Hour S2", 8, "Arial", LimeGreen);
   }
   else
    {
     ObjectMove("Hr_S2_Label", 0, Time[20], HourS2);
    }

//---------------------------------------------------------

 if(ObjectFind("Hr_S3_Line") != 0)
   {
    ObjectCreate("Hr_S3_Line", OBJ_HLINE,0, CurTime(),HourS3);
    ObjectSet("Hr_S3_Line", OBJPROP_COLOR, LimeGreen);
    ObjectSet("Hr_S3_Line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
   }
   else
    {
     ObjectMove("Hr_S3_Line", 0, Time[20], HourS3);
    }
   
 if(ObjectFind("Hr_S3_Label") != 0)
   {
    ObjectCreate("Hr_S3_Label", OBJ_TEXT, 0, Time[20], HourS3);
    ObjectSetText("Hr_S3_Label", "Hour S3", 8, "Arial", LimeGreen);
   }
   else
    {
     ObjectMove("Hr_S3_Label", 0, Time[20], HourS3);
    }
 }
ObjectsRedraw();
}

return(0);